Modules/Admin/Routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::prefix('admin')->name('admin.')->middleware('auth', 'admin.auth')->group(function () {
    Route::get('/', function () {
        return view('admin::admin.index');
    })->name('admin.');

    Route::resource('users', 'user\UsersController');

    Route::get('/{user}/permission', 'PermissionController@create')->name('user.permission')->middleware('can:staff-user-permission');
    Route::post('/{user}/permission', 'PermissionController@store')->name('user.permission.store')->middleware('can:staff-user-permission');

    Route::resource('permission', 'PermissionController');

    Route::resource('role', 'RoleController');

    Route::resource('product', 'ProductController');

    Route::get('comments/unapproved', 'CommentsController@unapproved')->name('comments.unapproved');
    Route::resource('comments', 'CommentsController');

    Route::resource('category', 'CategoryController');

    Route::post('/attribute/values', 'AttributeController@getValues');

    Route::resource('orders', 'OrderController');
    Route::get('order/{order}/payment', 'OrderController@payment')->name('order.payment');

    Route::resource('product.gallery', 'ProductGalleryController');

    Route::resource('discount', 'DiscountController');


    Route::get('module', 'MainController@index')->name('module.index');
    Route::put('module/{module}/disable', 'MainController@disable')->name('module.disable');
    Route::put('module/{module}/enable', 'MainController@enable')->name('module.enable');


});

Modules/Admin/Http/Controllers/ProductController.php
<?php

namespace Modules\Admin\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Validation\Rule;
use Modules\Attribute\Entities\Attribute;
use Modules\Product\Entities\Product;

class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $products = Product::query();

        if ($keyboard = \request('search')) {
            $products->where('name', 'LIKE', "%{$keyboard}%")
                ->orWhere('description', 'LIKE', "%%{$keyboard}%");
        }

        $products = $products->latest()->paginate(20);

        return view('admin::admin.product.all', compact('products'));


    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin::admin.product.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        $data = $request->validate([
            'title' => ['required', 'max:255'],
            'price' => ['required', 'numeric'],
            'inventory' => ['required', 'numeric'],
            'image' => ['required'],
            'description' => ['required'],
            'categories' => ['required'],
            'attributes' => ['array']
        ]);

//this code work at not file manger
//        $file = $request->file('image');
//        $directory = '/images/' . now()->year . '/' . now()->month . '/' . now()->day . '/';
//        $file->move(public_path($directory), $file->getClientOriginalName());
//
//        $data['image'] = $directory . $file->getClientOriginalName();

        $product = auth()->user()->products()->create($data);
        $product->categories()->sync($data['categories']);
        if (isset($data['attributes'])) {
            $this->attachAttributesToProduct($product, $data);
        }


        alert()->success('ثبت شد');

        return redirect(route('admin.product.index'));

    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param \App\Product $product
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $product)
    {
        return view('admin::admin.product.edit', compact('product'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param \App\Product $product
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Product $product)
    {

        $data = $request->validate([
            'title' => ['required', 'max:255', Rule::unique('products')->ignore($product->id), 'string'],
            'price' => ['required', 'numeric'],
            'inventory' => ['required', 'numeric'],
            'image' => ['required'],
            'description' => ['required'],
            'categories' => ['required'],
            'attributes' => ['array']
        ]);

        //this code work at not file manger
//        if ($request->file('image')) {
//            $request->validate([
//                'image' => ['required', 'mimes:jpg,bmp,png']
//            ]);
//
//
//            if (File::exists(public_path($product->image))) {
//                File::delete(public_path($product->image));
//            }
//            $file = $request->file('image');
//            $directory = '/images/' . now()->year . '/' . now()->month . '/' . now()->day . '/';
//            $file->move(public_path($directory), $file->getClientOriginalName());
//
//            $data['image'] = $directory . $file->getClientOriginalName();
//        }


        $product->update($data);

        $product->categories()->sync($data['categories']);

        $product->attributes()->detach();

        if (isset($data['attributes'])) {
            $this->attachAttributesToProduct($product, $data);
        }

        alert()->success('ویرایش شد');

        return redirect(route('admin.product.index'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param \App\Product $product
     * @return \Illuminate\Http\Response
     */
    public function destroy(Product $product)
    {
        $product->delete();
        alert()->success('حذف شد');
        return redirect(route('admin.product.index'));
    }

    /**
     * @param $attributes
     * @param $product
     */
    public function attachAttributesToProduct(Product $product, array $data): void
    {
        $attribute = collect($data['attributes']);
        $attribute->each(function ($item) use ($product) {
            if (is_null($item['name']) || is_null($item['value'])) return;

            $attr = Attribute::firstOrCreate([
                'name' => $item['name']
            ]);

            $attrVal = $attr->values()->firstOrCreate([
                'value' => $item['value']
            ]);

            $product->attributes()->attach($attr->id, ['value_id' => $attrVal->id]);

        });
    }
}

Modules/Admin/Resources/views/admin/product/gallery/all.blade.php
@component('admin::admin.layout.content' , ['title' => 'لیست تصاویر'])
    @slot('breadcrumb')
        <li class="breadcrumb-item"><a href="/admin">پنل مدیریت</a></li>
        <li class="breadcrumb-item">{{ $product->title }}</li>
        <li class="breadcrumb-item active">گالری تصاویر</li>
    @endslot

    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">تصاویر</h3>

                    <div class="card-tools d-flex">
                        <div class="btn-group-sm mr-1">
                            <a href="{{ route('admin.product.gallery.create' , ['product' => $product->id]) }}" class="btn btn-info">ثبت تصویر جدید</a>
                        </div>
                    </div>
                </div>
                <!-- /.card-header -->
                <div class="card-body">
                    <div class="row">
                        @foreach($images as $image)
                            <div class="col-sm-2">
                                <a href="{{ url($image['image']) }}">
                                    <img src="{{ url($image['image']) }}" class="img-fluid mb-2" alt="{{ url($image['alt']) }}">
                                </a>
                                <form action="{{ route('admin.product.gallery.destroy' , ['product' => $product->id , 'gallery' => $image->id]) }}" id="image-{{ $image->id }}" method="post">
                                    @method('delete')
                                    @csrf
                                </form>
                                <a href="{{ route('admin.product.gallery.edit' , ['product' => $product->id , 'gallery' => $image->id]) }}" class="btn btn-sm btn-primary">ویرایش</a>
                                <a href="#" class="btn btn-sm btn-danger" onclick="document.getElementById('image-{{ $image->id }}').submit()">حذف</a>
                            </div>
                        @endforeach
                    </div>
                </div>
                <!-- /.card-body -->
                <div class="card-footer">
                    {{ $images->render() }}
                </div>
            </div>
            <!-- /.card -->
        </div>
    </div>

@endcomponent

Modules/Admin/Resources/views/admin/product/gallery/create.blade.php
@component('admin::admin.layout.content' , ['title' => 'ایجاد محصول'])
    @slot('breadcrumb')
        <li class="breadcrumb-item"><a href="/admin">پنل مدیریت</a></li>
        <li class="breadcrumb-item">{{ $product->title }}</li>
        <li class="breadcrumb-item active">ثبت تصویر</li>
    @endslot

    @slot('script')
        <script>
            let createNewPic = ({ id }) => {
                return `
                    <div class="row image-field" id="image-${id}">
                        <div class="col-5">
                            <div class="form-group">
                                 <label>تصویر</label>
                                 <div class="input-group">
                                    <input type="text" class="form-control image_label" name="images[${id}][image]"
                                           aria-label="Image" aria-describedby="button-image">
                                    <div class="input-group-append">
                                        <button class="btn btn-outline-secondary button-image" type="button">انتخاب</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-5">
                            <div class="form-group">
                                 <label>عنوان تصویر</label>
                                 <input type="text" name="images[${id}][alt]" class="form-control">
                            </div>
                        </div>
                         <div class="col-2">
                            <label >اقدامات</label>
                            <div>
                                <button type="button" class="btn btn-sm btn-warning" onclick="document.getElementById('image-${id}').remove()">حذف</button>
                            </div>
                        </div>
                    </div>
                `
            }

            $('#add_product_image').click(function() {
                let imagesSection = $('#images_section');
                let id = imagesSection.children().length;

                imagesSection.append(
                    createNewPic({
                        id
                    })
                );

            });
            $('#add_product_image').click();


            // input
            let image;
            $('body').on('click','.button-image' , (event) => {
                event.preventDefault();

                image = $(event.target).closest('.image-field');

                window.open('/file-manager/fm-button', 'fm', 'width=1400,height=800');
            });

            // set file link
            function fmSetLink($url) {
                image.find('.image_label').first().val($url);
            }
        </script>
    @endslot

    <div class="row">
        <div class="col-lg-12">
{{--            @include('admin.layouts.errors')--}}
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">ثبت تصویر</h3>
                </div>
                <!-- /.card-header -->
                <!-- form start -->
                <form class="form-horizontal" action="{{ route('admin.product.gallery.store' , ['product' => $product->id]) }}" method="POST" enctype="multipart/form-data">
                    @csrf

                    <div class="card-body">
{{--                        <h6>ویژگی محصول</h6>--}}
{{--                        <hr>--}}
                        <div id="images_section">

                        </div>
                        <button class="btn btn-sm btn-danger" type="button" id="add_product_image">تصویر جدید</button>
                    </div>
                    <!-- /.card-body -->
                    <div class="card-footer">
                        <button type="submit" class="btn btn-info">ثبت تصاویر</button>
                        <a href="{{ route('admin.product.gallery.index' , ['product' => $product->id]) }}" class="btn btn-default float-left">لغو</a>
                    </div>
                    <!-- /.card-footer -->
                </form>
            </div>
        </div>
    </div>



@endcomponent

Modules/Admin/Resources/views/admin/product/gallery/edit.blade.php
@component('admin::admin.layout.content' , ['title' => 'ایجاد محصول'])
    @slot('breadcrumb')
        <li class="breadcrumb-item"><a href="/admin">پنل مدیریت</a></li>
        <li class="breadcrumb-item">{{ $product->title }}</li>
        <li class="breadcrumb-item active">ویرایش تصویر</li>
    @endslot

    @slot('script')
        <script>
            // input
            let image;
            $('body').on('click','.button-image' , (event) => {
                event.preventDefault();

                image = $(event.target).closest('.image-field');

                window.open('/file-manager/fm-button', 'fm', 'width=1400,height=800');
            });

            // set file link
            function fmSetLink($url) {
                image.find('.image_label').first().val($url);
            }
        </script>
    @endslot

    <div class="row">
        <div class="col-lg-12">
{{--            @include('admin.layouts.errors')--}}
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">ویرایش تصویر</h3>
                </div>
                <!-- /.card-header -->
                <!-- form start -->
                <form class="form-horizontal" action="{{ route('admin.product.gallery.update' , ['product' => $product->id, 'gallery' => $gallery->id ]) }}" method="POST" enctype="multipart/form-data">
                    @csrf
                    @method('patch')

                    <div class="card-body">
{{--                        <h6>ویژگی محصول</h6>--}}
{{--                        <hr>--}}
                        <div id="images_section">
                            <div class="row image-field">
                                <div class="col-5">
                                    <div class="form-group">
                                        <label>تصویر</label>
                                        <div class="input-group">
                                            <input type="text" class="form-control image_label" name="image" value="{{ old('image' , $gallery->image) }}"
                                                   aria-label="Image" aria-describedby="button-image">
                                            <div class="input-group-append">
                                                <button class="btn btn-outline-secondary button-image" type="button">انتخاب</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-5">
                                    <div class="form-group">
                                        <label>عنوان تصویر</label>
                                        <input type="text" name="alt" class="form-control" value="{{ old('alt' , $gallery->alt) }}">
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- /.card-body -->
                    <div class="card-footer">
                        <button type="submit" class="btn btn-info">ویرایش تصاویر</button>
                        <a href="{{ route('admin.product.gallery.index' , ['product' => $product->id]) }}" class="btn btn-default float-left">لغو</a>
                    </div>
                    <!-- /.card-footer -->
                </form>
            </div>
        </div>
    </div>



@endcomponent